Loading...
Searching...
No Matches
or/unmql: Multiply by Q from QL factorization
Dense LA » Orthogonal/unitary factorizations » QL factorization

## Functions

magma_int_t | magma_cunmql (magma_side_t side, magma_trans_t trans, magma_int_t m, magma_int_t n, magma_int_t k, magmaFloatComplex *A, magma_int_t lda, magmaFloatComplex *tau, magmaFloatComplex *C, magma_int_t ldc, magmaFloatComplex *work, magma_int_t lwork, magma_int_t *info)
| CUNMQL overwrites the general complex M-by-N matrix C with.
magma_int_t | magma_cunmql2_gpu (magma_side_t side, magma_trans_t trans, magma_int_t m, magma_int_t n, magma_int_t k, magmaFloatComplex_ptr dA, magma_int_t ldda, magmaFloatComplex *tau, magmaFloatComplex_ptr dC, magma_int_t lddc, const magmaFloatComplex *wA, magma_int_t ldwa, magma_int_t *info)
| CUNMQL overwrites the general complex M-by-N matrix C with.
magma_int_t | magma_dormql (magma_side_t side, magma_trans_t trans, magma_int_t m, magma_int_t n, magma_int_t k, double *A, magma_int_t lda, double *tau, double *C, magma_int_t ldc, double *work, magma_int_t lwork, magma_int_t *info)
| DORMQL overwrites the general real M-by-N matrix C with.
magma_int_t | magma_dormql2_gpu (magma_side_t side, magma_trans_t trans, magma_int_t m, magma_int_t n, magma_int_t k, magmaDouble_ptr dA, magma_int_t ldda, double *tau, magmaDouble_ptr dC, magma_int_t lddc, const double *wA, magma_int_t ldwa, magma_int_t *info)
| DORMQL overwrites the general real M-by-N matrix C with.
magma_int_t | magma_sormql (magma_side_t side, magma_trans_t trans, magma_int_t m, magma_int_t n, magma_int_t k, float *A, magma_int_t lda, float *tau, float *C, magma_int_t ldc, float *work, magma_int_t lwork, magma_int_t *info)
| SORMQL overwrites the general real M-by-N matrix C with.
magma_int_t | magma_sormql2_gpu (magma_side_t side, magma_trans_t trans, magma_int_t m, magma_int_t n, magma_int_t k, magmaFloat_ptr dA, magma_int_t ldda, float *tau, magmaFloat_ptr dC, magma_int_t lddc, const float *wA, magma_int_t ldwa, magma_int_t *info)
| SORMQL overwrites the general real M-by-N matrix C with.
magma_int_t | magma_zunmql (magma_side_t side, magma_trans_t trans, magma_int_t m, magma_int_t n, magma_int_t k, magmaDoubleComplex *A, magma_int_t lda, magmaDoubleComplex *tau, magmaDoubleComplex *C, magma_int_t ldc, magmaDoubleComplex *work, magma_int_t lwork, magma_int_t *info)
| ZUNMQL overwrites the general complex M-by-N matrix C with.
magma_int_t | magma_zunmql2_gpu (magma_side_t side, magma_trans_t trans, magma_int_t m, magma_int_t n, magma_int_t k, magmaDoubleComplex_ptr dA, magma_int_t ldda, magmaDoubleComplex *tau, magmaDoubleComplex_ptr dC, magma_int_t lddc, const magmaDoubleComplex *wA, magma_int_t ldwa, magma_int_t *info)
| ZUNMQL overwrites the general complex M-by-N matrix C with.

## Detailed Description

## Function Documentation

## magma_cunmql()

magma_int_t magma_cunmql | ( | magma_side_t | side,
|  | magma_trans_t | trans,
|  | magma_int_t | m,
|  | magma_int_t | n,
|  | magma_int_t | k,
|  | magmaFloatComplex * | A,
|  | magma_int_t | lda,
|  | magmaFloatComplex * | tau,
|  | magmaFloatComplex * | C,
|  | magma_int_t | ldc,
|  | magmaFloatComplex * | work,
|  | magma_int_t | lwork,
|  | magma_int_t * | info )

CUNMQL overwrites the general complex M-by-N matrix C with.

                              SIDE = MagmaLeft   SIDE = MagmaRight
    TRANS = MagmaNoTrans:     Q * C              C * Q
    TRANS = Magma_ConjTrans:  Q**H * C           C * Q**H

where Q is a complex unitary matrix defined as the product of k elementary reflectors

      Q = H(k) . . . H(2) H(1)

as returned by CGEQLF. Q is of order M if SIDE = MagmaLeft and of order N if SIDE = MagmaRight.

Parameters

  [in]

  side

  magma_side_t
  - = MagmaLeft: apply Q or Q**H from the Left;
  - = MagmaRight: apply Q or Q**H from the Right.

  [in]

  trans

  magma_trans_t
  - = MagmaNoTrans: No transpose, apply Q;
  - = Magma_ConjTrans: Conjugate transpose, apply Q**H.

  [in] | m | INTEGER The number of rows of the matrix C. M >= 0.
  [in] | n | INTEGER The number of columns of the matrix C. N >= 0.
  [in] | k | INTEGER The number of elementary reflectors whose product defines the matrix Q. If SIDE = MagmaLeft, M >= K >= 0; if SIDE = MagmaRight, N >= K >= 0.
  [in] | A | COMPLEX array, dimension (LDA,K) The i-th column must contain the vector which defines the elementary reflector H(i), for i = 1,2,...,k, as returned by CGEQLF in the last k columns of its array argument A. A is modified by the routine but restored on exit.
  [in] | lda | INTEGER The leading dimension of the array A. If SIDE = MagmaLeft, LDA >= max(1,M); if SIDE = MagmaRight, LDA >= max(1,N).
  [in] | tau | COMPLEX array, dimension (K) TAU(i) must contain the scalar factor of the elementary reflector H(i), as returned by CGEQLF.
  [in,out] | C | COMPLEX array, dimension (LDC,N) On entry, the M-by-N matrix C. On exit, C is overwritten by Q*C or Q**H*C or C*Q**H or C*Q.
  [in] | ldc | INTEGER The leading dimension of the array C. LDC >= max(1,M).
  [out] | work | (workspace) COMPLEX array, dimension (MAX(1,LWORK)) On exit, if INFO = 0, WORK[0] returns the optimal LWORK.

  [in]

  lwork

  INTEGER The dimension of the array WORK. If SIDE = MagmaLeft, LWORK >= max(1,N); if SIDE = MagmaRight, LWORK >= max(1,M). For optimum performance if SIDE = MagmaLeft, LWORK >= N*NB; if SIDE = MagmaRight, LWORK >= M*NB, where NB is the optimal blocksize.
  If LWORK = -1, then a workspace query is assumed; the routine only calculates the optimal size of the WORK array, returns this value as the first entry of the WORK array, and no error message related to LWORK is issued by XERBLA.

  [out]

  info

  INTEGER
  - = 0: successful exit
  - < 0: if INFO = -i, the i-th argument had an illegal value

## magma_cunmql2_gpu()

magma_int_t magma_cunmql2_gpu | ( | magma_side_t | side,
|  | magma_trans_t | trans,
|  | magma_int_t | m,
|  | magma_int_t | n,
|  | magma_int_t | k,
|  | magmaFloatComplex_ptr | dA,
|  | magma_int_t | ldda,
|  | magmaFloatComplex * | tau,
|  | magmaFloatComplex_ptr | dC,
|  | magma_int_t | lddc,
|  | const magmaFloatComplex * | wA,
|  | magma_int_t | ldwa,
|  | magma_int_t * | info )

CUNMQL overwrites the general complex M-by-N matrix C with.

                               SIDE = MagmaLeft   SIDE = MagmaRight
    TRANS = MagmaNoTrans:      Q * C              C * Q
    TRANS = Magma_ConjTrans:   Q**H * C           C * Q**H

where Q is a complex unitary matrix defined as the product of k elementary reflectors

      Q = H(k) . . . H(2) H(1)

as returned by CGEQLF. Q is of order M if SIDE = MagmaLeft and of order N if SIDE = MagmaRight.

Parameters

  [in]

  side

  magma_side_t
  - = MagmaLeft: apply Q or Q**H from the Left;
  - = MagmaRight: apply Q or Q**H from the Right.

  [in]

  trans

  magma_trans_t
  - = MagmaNoTrans: No transpose, apply Q;
  - = Magma_ConjTrans: Conjugate transpose, apply Q**H.

  [in] | m | INTEGER The number of rows of the matrix C. M >= 0.
  [in] | n | INTEGER The number of columns of the matrix C. N >= 0.
  [in] | k | INTEGER The number of elementary reflectors whose product defines the matrix Q. If SIDE = MagmaLeft, M >= K >= 0; if SIDE = MagmaRight, N >= K >= 0.
  [in,out] | dA | COMPLEX array on the GPU, dimension (LDDA,K) The i-th column must contain the vector which defines the elementary reflector H(i), for i = 1,2,...,k, as returned by CGEQLF in the last k columns of its array argument dA. The diagonal and the lower part are destroyed, the reflectors are not modified.
  [in] | ldda | INTEGER The leading dimension of the array dA. If SIDE = MagmaLeft, LDDA >= max(1,M); if SIDE = MagmaRight, LDDA >= max(1,N).
  [in] | tau | COMPLEX array, dimension (K) TAU(i) must contain the scalar factor of the elementary reflector H(i), as returned by CGEQLF.
  [in,out] | dC | COMPLEX array on the GPU, dimension (LDDC,N) On entry, the M-by-N matrix C. On exit, C is overwritten by (Q*C) or (Q**H * C) or (C * Q**H) or (C*Q).
  [in] | lddc | INTEGER The leading dimension of the array dC. LDDC >= max(1,M).
  [in] | wA | COMPLEX array, dimension (LDWA,M) if SIDE = MagmaLeft (LDWA,N) if SIDE = MagmaRight The vectors which define the elementary reflectors, as returned by CHETRD_GPU. (A copy of the upper or lower part of dA, on the host.)
  [in] | ldwa | INTEGER The leading dimension of the array wA. If SIDE = MagmaLeft, LDWA >= max(1,M); if SIDE = MagmaRight, LDWA >= max(1,N).

  [out]

  info

  INTEGER
  - = 0: successful exit
  - < 0: if INFO = -i, the i-th argument had an illegal value

## magma_dormql()

magma_int_t magma_dormql | ( | magma_side_t | side,
|  | magma_trans_t | trans,
|  | magma_int_t | m,
|  | magma_int_t | n,
|  | magma_int_t | k,
|  | double * | A,
|  | magma_int_t | lda,
|  | double * | tau,
|  | double * | C,
|  | magma_int_t | ldc,
|  | double * | work,
|  | magma_int_t | lwork,
|  | magma_int_t * | info )

DORMQL overwrites the general real M-by-N matrix C with.

                              SIDE = MagmaLeft   SIDE = MagmaRight
    TRANS = MagmaNoTrans:     Q * C              C * Q
    TRANS = MagmaTrans:  Q**H * C           C * Q**H

where Q is a real orthogonal matrix defined as the product of k elementary reflectors

      Q = H(k) . . . H(2) H(1)

as returned by DGEQLF. Q is of order M if SIDE = MagmaLeft and of order N if SIDE = MagmaRight.

Parameters

  [in]

  side

  magma_side_t
  - = MagmaLeft: apply Q or Q**H from the Left;
  - = MagmaRight: apply Q or Q**H from the Right.

  [in]

  trans

  magma_trans_t
  - = MagmaNoTrans: No transpose, apply Q;
  - = MagmaTrans: Conjugate transpose, apply Q**H.

  [in] | m | INTEGER The number of rows of the matrix C. M >= 0.
  [in] | n | INTEGER The number of columns of the matrix C. N >= 0.
  [in] | k | INTEGER The number of elementary reflectors whose product defines the matrix Q. If SIDE = MagmaLeft, M >= K >= 0; if SIDE = MagmaRight, N >= K >= 0.
  [in] | A | DOUBLE PRECISION array, dimension (LDA,K) The i-th column must contain the vector which defines the elementary reflector H(i), for i = 1,2,...,k, as returned by DGEQLF in the last k columns of its array argument A. A is modified by the routine but restored on exit.
  [in] | lda | INTEGER The leading dimension of the array A. If SIDE = MagmaLeft, LDA >= max(1,M); if SIDE = MagmaRight, LDA >= max(1,N).
  [in] | tau | DOUBLE PRECISION array, dimension (K) TAU(i) must contain the scalar factor of the elementary reflector H(i), as returned by DGEQLF.
  [in,out] | C | DOUBLE PRECISION array, dimension (LDC,N) On entry, the M-by-N matrix C. On exit, C is overwritten by Q*C or Q**H*C or C*Q**H or C*Q.
  [in] | ldc | INTEGER The leading dimension of the array C. LDC >= max(1,M).
  [out] | work | (workspace) DOUBLE PRECISION array, dimension (MAX(1,LWORK)) On exit, if INFO = 0, WORK[0] returns the optimal LWORK.

  [in]

  lwork

  INTEGER The dimension of the array WORK. If SIDE = MagmaLeft, LWORK >= max(1,N); if SIDE = MagmaRight, LWORK >= max(1,M). For optimum performance if SIDE = MagmaLeft, LWORK >= N*NB; if SIDE = MagmaRight, LWORK >= M*NB, where NB is the optimal blocksize.
  If LWORK = -1, then a workspace query is assumed; the routine only calculates the optimal size of the WORK array, returns this value as the first entry of the WORK array, and no error message related to LWORK is issued by XERBLA.

  [out]

  info

  INTEGER
  - = 0: successful exit
  - < 0: if INFO = -i, the i-th argument had an illegal value

## magma_dormql2_gpu()

magma_int_t magma_dormql2_gpu | ( | magma_side_t | side,
|  | magma_trans_t | trans,
|  | magma_int_t | m,
|  | magma_int_t | n,
|  | magma_int_t | k,
|  | magmaDouble_ptr | dA,
|  | magma_int_t | ldda,
|  | double * | tau,
|  | magmaDouble_ptr | dC,
|  | magma_int_t | lddc,
|  | const double * | wA,
|  | magma_int_t | ldwa,
|  | magma_int_t * | info )

DORMQL overwrites the general real M-by-N matrix C with.

                               SIDE = MagmaLeft   SIDE = MagmaRight
    TRANS = MagmaNoTrans:      Q * C              C * Q
    TRANS = MagmaTrans:   Q**H * C           C * Q**H

where Q is a real orthogonal matrix defined as the product of k elementary reflectors

      Q = H(k) . . . H(2) H(1)

as returned by DGEQLF. Q is of order M if SIDE = MagmaLeft and of order N if SIDE = MagmaRight.

Parameters

  [in]

  side

  magma_side_t
  - = MagmaLeft: apply Q or Q**H from the Left;
  - = MagmaRight: apply Q or Q**H from the Right.

  [in]

  trans

  magma_trans_t
  - = MagmaNoTrans: No transpose, apply Q;
  - = MagmaTrans: Conjugate transpose, apply Q**H.

  [in] | m | INTEGER The number of rows of the matrix C. M >= 0.
  [in] | n | INTEGER The number of columns of the matrix C. N >= 0.
  [in] | k | INTEGER The number of elementary reflectors whose product defines the matrix Q. If SIDE = MagmaLeft, M >= K >= 0; if SIDE = MagmaRight, N >= K >= 0.
  [in,out] | dA | DOUBLE PRECISION array on the GPU, dimension (LDDA,K) The i-th column must contain the vector which defines the elementary reflector H(i), for i = 1,2,...,k, as returned by DGEQLF in the last k columns of its array argument dA. The diagonal and the lower part are destroyed, the reflectors are not modified.
  [in] | ldda | INTEGER The leading dimension of the array dA. If SIDE = MagmaLeft, LDDA >= max(1,M); if SIDE = MagmaRight, LDDA >= max(1,N).
  [in] | tau | DOUBLE PRECISION array, dimension (K) TAU(i) must contain the scalar factor of the elementary reflector H(i), as returned by DGEQLF.
  [in,out] | dC | DOUBLE PRECISION array on the GPU, dimension (LDDC,N) On entry, the M-by-N matrix C. On exit, C is overwritten by (Q*C) or (Q**H * C) or (C * Q**H) or (C*Q).
  [in] | lddc | INTEGER The leading dimension of the array dC. LDDC >= max(1,M).
  [in] | wA | DOUBLE PRECISION array, dimension (LDWA,M) if SIDE = MagmaLeft (LDWA,N) if SIDE = MagmaRight The vectors which define the elementary reflectors, as returned by DSYTRD_GPU. (A copy of the upper or lower part of dA, on the host.)
  [in] | ldwa | INTEGER The leading dimension of the array wA. If SIDE = MagmaLeft, LDWA >= max(1,M); if SIDE = MagmaRight, LDWA >= max(1,N).

  [out]

  info

  INTEGER
  - = 0: successful exit
  - < 0: if INFO = -i, the i-th argument had an illegal value

## magma_sormql()

magma_int_t magma_sormql | ( | magma_side_t | side,
|  | magma_trans_t | trans,
|  | magma_int_t | m,
|  | magma_int_t | n,
|  | magma_int_t | k,
|  | float * | A,
|  | magma_int_t | lda,
|  | float * | tau,
|  | float * | C,
|  | magma_int_t | ldc,
|  | float * | work,
|  | magma_int_t | lwork,
|  | magma_int_t * | info )

SORMQL overwrites the general real M-by-N matrix C with.

                              SIDE = MagmaLeft   SIDE = MagmaRight
    TRANS = MagmaNoTrans:     Q * C              C * Q
    TRANS = MagmaTrans:  Q**H * C           C * Q**H

where Q is a real orthogonal matrix defined as the product of k elementary reflectors

      Q = H(k) . . . H(2) H(1)

as returned by SGEQLF. Q is of order M if SIDE = MagmaLeft and of order N if SIDE = MagmaRight.

Parameters

  [in]

  side

  magma_side_t
  - = MagmaLeft: apply Q or Q**H from the Left;
  - = MagmaRight: apply Q or Q**H from the Right.

  [in]

  trans

  magma_trans_t
  - = MagmaNoTrans: No transpose, apply Q;
  - = MagmaTrans: Conjugate transpose, apply Q**H.

  [in] | m | INTEGER The number of rows of the matrix C. M >= 0.
  [in] | n | INTEGER The number of columns of the matrix C. N >= 0.
  [in] | k | INTEGER The number of elementary reflectors whose product defines the matrix Q. If SIDE = MagmaLeft, M >= K >= 0; if SIDE = MagmaRight, N >= K >= 0.
  [in] | A | REAL array, dimension (LDA,K) The i-th column must contain the vector which defines the elementary reflector H(i), for i = 1,2,...,k, as returned by SGEQLF in the last k columns of its array argument A. A is modified by the routine but restored on exit.
  [in] | lda | INTEGER The leading dimension of the array A. If SIDE = MagmaLeft, LDA >= max(1,M); if SIDE = MagmaRight, LDA >= max(1,N).
  [in] | tau | REAL array, dimension (K) TAU(i) must contain the scalar factor of the elementary reflector H(i), as returned by SGEQLF.
  [in,out] | C | REAL array, dimension (LDC,N) On entry, the M-by-N matrix C. On exit, C is overwritten by Q*C or Q**H*C or C*Q**H or C*Q.
  [in] | ldc | INTEGER The leading dimension of the array C. LDC >= max(1,M).
  [out] | work | (workspace) REAL array, dimension (MAX(1,LWORK)) On exit, if INFO = 0, WORK[0] returns the optimal LWORK.

  [in]

  lwork

  INTEGER The dimension of the array WORK. If SIDE = MagmaLeft, LWORK >= max(1,N); if SIDE = MagmaRight, LWORK >= max(1,M). For optimum performance if SIDE = MagmaLeft, LWORK >= N*NB; if SIDE = MagmaRight, LWORK >= M*NB, where NB is the optimal blocksize.
  If LWORK = -1, then a workspace query is assumed; the routine only calculates the optimal size of the WORK array, returns this value as the first entry of the WORK array, and no error message related to LWORK is issued by XERBLA.

  [out]

  info

  INTEGER
  - = 0: successful exit
  - < 0: if INFO = -i, the i-th argument had an illegal value

## magma_sormql2_gpu()

magma_int_t magma_sormql2_gpu | ( | magma_side_t | side,
|  | magma_trans_t | trans,
|  | magma_int_t | m,
|  | magma_int_t | n,
|  | magma_int_t | k,
|  | magmaFloat_ptr | dA,
|  | magma_int_t | ldda,
|  | float * | tau,
|  | magmaFloat_ptr | dC,
|  | magma_int_t | lddc,
|  | const float * | wA,
|  | magma_int_t | ldwa,
|  | magma_int_t * | info )

SORMQL overwrites the general real M-by-N matrix C with.

                               SIDE = MagmaLeft   SIDE = MagmaRight
    TRANS = MagmaNoTrans:      Q * C              C * Q
    TRANS = MagmaTrans:   Q**H * C           C * Q**H

where Q is a real orthogonal matrix defined as the product of k elementary reflectors

      Q = H(k) . . . H(2) H(1)

as returned by SGEQLF. Q is of order M if SIDE = MagmaLeft and of order N if SIDE = MagmaRight.

Parameters

  [in]

  side

  magma_side_t
  - = MagmaLeft: apply Q or Q**H from the Left;
  - = MagmaRight: apply Q or Q**H from the Right.

  [in]

  trans

  magma_trans_t
  - = MagmaNoTrans: No transpose, apply Q;
  - = MagmaTrans: Conjugate transpose, apply Q**H.

  [in] | m | INTEGER The number of rows of the matrix C. M >= 0.
  [in] | n | INTEGER The number of columns of the matrix C. N >= 0.
  [in] | k | INTEGER The number of elementary reflectors whose product defines the matrix Q. If SIDE = MagmaLeft, M >= K >= 0; if SIDE = MagmaRight, N >= K >= 0.
  [in,out] | dA | REAL array on the GPU, dimension (LDDA,K) The i-th column must contain the vector which defines the elementary reflector H(i), for i = 1,2,...,k, as returned by SGEQLF in the last k columns of its array argument dA. The diagonal and the lower part are destroyed, the reflectors are not modified.
  [in] | ldda | INTEGER The leading dimension of the array dA. If SIDE = MagmaLeft, LDDA >= max(1,M); if SIDE = MagmaRight, LDDA >= max(1,N).
  [in] | tau | REAL array, dimension (K) TAU(i) must contain the scalar factor of the elementary reflector H(i), as returned by SGEQLF.
  [in,out] | dC | REAL array on the GPU, dimension (LDDC,N) On entry, the M-by-N matrix C. On exit, C is overwritten by (Q*C) or (Q**H * C) or (C * Q**H) or (C*Q).
  [in] | lddc | INTEGER The leading dimension of the array dC. LDDC >= max(1,M).
  [in] | wA | REAL array, dimension (LDWA,M) if SIDE = MagmaLeft (LDWA,N) if SIDE = MagmaRight The vectors which define the elementary reflectors, as returned by SSYTRD_GPU. (A copy of the upper or lower part of dA, on the host.)
  [in] | ldwa | INTEGER The leading dimension of the array wA. If SIDE = MagmaLeft, LDWA >= max(1,M); if SIDE = MagmaRight, LDWA >= max(1,N).

  [out]

  info

  INTEGER
  - = 0: successful exit
  - < 0: if INFO = -i, the i-th argument had an illegal value

## magma_zunmql()

magma_int_t magma_zunmql | ( | magma_side_t | side,
|  | magma_trans_t | trans,
|  | magma_int_t | m,
|  | magma_int_t | n,
|  | magma_int_t | k,
|  | magmaDoubleComplex * | A,
|  | magma_int_t | lda,
|  | magmaDoubleComplex * | tau,
|  | magmaDoubleComplex * | C,
|  | magma_int_t | ldc,
|  | magmaDoubleComplex * | work,
|  | magma_int_t | lwork,
|  | magma_int_t * | info )

ZUNMQL overwrites the general complex M-by-N matrix C with.

                              SIDE = MagmaLeft   SIDE = MagmaRight
    TRANS = MagmaNoTrans:     Q * C              C * Q
    TRANS = Magma_ConjTrans:  Q**H * C           C * Q**H

where Q is a complex unitary matrix defined as the product of k elementary reflectors

      Q = H(k) . . . H(2) H(1)

as returned by ZGEQLF. Q is of order M if SIDE = MagmaLeft and of order N if SIDE = MagmaRight.

Parameters

  [in]

  side

  magma_side_t
  - = MagmaLeft: apply Q or Q**H from the Left;
  - = MagmaRight: apply Q or Q**H from the Right.

  [in]

  trans

  magma_trans_t
  - = MagmaNoTrans: No transpose, apply Q;
  - = Magma_ConjTrans: Conjugate transpose, apply Q**H.

  [in] | m | INTEGER The number of rows of the matrix C. M >= 0.
  [in] | n | INTEGER The number of columns of the matrix C. N >= 0.
  [in] | k | INTEGER The number of elementary reflectors whose product defines the matrix Q. If SIDE = MagmaLeft, M >= K >= 0; if SIDE = MagmaRight, N >= K >= 0.
  [in] | A | COMPLEX_16 array, dimension (LDA,K) The i-th column must contain the vector which defines the elementary reflector H(i), for i = 1,2,...,k, as returned by ZGEQLF in the last k columns of its array argument A. A is modified by the routine but restored on exit.
  [in] | lda | INTEGER The leading dimension of the array A. If SIDE = MagmaLeft, LDA >= max(1,M); if SIDE = MagmaRight, LDA >= max(1,N).
  [in] | tau | COMPLEX_16 array, dimension (K) TAU(i) must contain the scalar factor of the elementary reflector H(i), as returned by ZGEQLF.
  [in,out] | C | COMPLEX_16 array, dimension (LDC,N) On entry, the M-by-N matrix C. On exit, C is overwritten by Q*C or Q**H*C or C*Q**H or C*Q.
  [in] | ldc | INTEGER The leading dimension of the array C. LDC >= max(1,M).
  [out] | work | (workspace) COMPLEX_16 array, dimension (MAX(1,LWORK)) On exit, if INFO = 0, WORK[0] returns the optimal LWORK.

  [in]

  lwork

  INTEGER The dimension of the array WORK. If SIDE = MagmaLeft, LWORK >= max(1,N); if SIDE = MagmaRight, LWORK >= max(1,M). For optimum performance if SIDE = MagmaLeft, LWORK >= N*NB; if SIDE = MagmaRight, LWORK >= M*NB, where NB is the optimal blocksize.
  If LWORK = -1, then a workspace query is assumed; the routine only calculates the optimal size of the WORK array, returns this value as the first entry of the WORK array, and no error message related to LWORK is issued by XERBLA.

  [out]

  info

  INTEGER
  - = 0: successful exit
  - < 0: if INFO = -i, the i-th argument had an illegal value

## magma_zunmql2_gpu()

magma_int_t magma_zunmql2_gpu | ( | magma_side_t | side,
|  | magma_trans_t | trans,
|  | magma_int_t | m,
|  | magma_int_t | n,
|  | magma_int_t | k,
|  | magmaDoubleComplex_ptr | dA,
|  | magma_int_t | ldda,
|  | magmaDoubleComplex * | tau,
|  | magmaDoubleComplex_ptr | dC,
|  | magma_int_t | lddc,
|  | const magmaDoubleComplex * | wA,
|  | magma_int_t | ldwa,
|  | magma_int_t * | info )

ZUNMQL overwrites the general complex M-by-N matrix C with.

                               SIDE = MagmaLeft   SIDE = MagmaRight
    TRANS = MagmaNoTrans:      Q * C              C * Q
    TRANS = Magma_ConjTrans:   Q**H * C           C * Q**H

where Q is a complex unitary matrix defined as the product of k elementary reflectors

      Q = H(k) . . . H(2) H(1)

as returned by ZGEQLF. Q is of order M if SIDE = MagmaLeft and of order N if SIDE = MagmaRight.

Parameters

  [in]

  side

  magma_side_t
  - = MagmaLeft: apply Q or Q**H from the Left;
  - = MagmaRight: apply Q or Q**H from the Right.

  [in]

  trans

  magma_trans_t
  - = MagmaNoTrans: No transpose, apply Q;
  - = Magma_ConjTrans: Conjugate transpose, apply Q**H.

  [in] | m | INTEGER The number of rows of the matrix C. M >= 0.
  [in] | n | INTEGER The number of columns of the matrix C. N >= 0.
  [in] | k | INTEGER The number of elementary reflectors whose product defines the matrix Q. If SIDE = MagmaLeft, M >= K >= 0; if SIDE = MagmaRight, N >= K >= 0.
  [in,out] | dA | COMPLEX_16 array on the GPU, dimension (LDDA,K) The i-th column must contain the vector which defines the elementary reflector H(i), for i = 1,2,...,k, as returned by ZGEQLF in the last k columns of its array argument dA. The diagonal and the lower part are destroyed, the reflectors are not modified.
  [in] | ldda | INTEGER The leading dimension of the array dA. If SIDE = MagmaLeft, LDDA >= max(1,M); if SIDE = MagmaRight, LDDA >= max(1,N).
  [in] | tau | COMPLEX_16 array, dimension (K) TAU(i) must contain the scalar factor of the elementary reflector H(i), as returned by ZGEQLF.
  [in,out] | dC | COMPLEX_16 array on the GPU, dimension (LDDC,N) On entry, the M-by-N matrix C. On exit, C is overwritten by (Q*C) or (Q**H * C) or (C * Q**H) or (C*Q).
  [in] | lddc | INTEGER The leading dimension of the array dC. LDDC >= max(1,M).
  [in] | wA | COMPLEX_16 array, dimension (LDWA,M) if SIDE = MagmaLeft (LDWA,N) if SIDE = MagmaRight The vectors which define the elementary reflectors, as returned by ZHETRD_GPU. (A copy of the upper or lower part of dA, on the host.)
  [in] | ldwa | INTEGER The leading dimension of the array wA. If SIDE = MagmaLeft, LDWA >= max(1,M); if SIDE = MagmaRight, LDWA >= max(1,N).

  [out]

  info

  INTEGER
  - = 0: successful exit
  - < 0: if INFO = -i, the i-th argument had an illegal value